;###############################################################################
/* Menu for LilBuilder

*/
;###############################################################################

;create all menus ans fill them
Menu_Create() {
  local StandardCtrls                                 ;global context

  Menu_Toolbox := MMenu_Create()                      ;create special menus
  Menu_ToolboxGuis := MMenu_Create()
  Toolbox_CreateMenu(Menu_Toolbox, Menu_ToolboxGuis)

  Menu_Gui := MMenu_Create()
  Gui_CreateMenu(Menu_Gui)

  Menu_MultiSelection := MMenu_Create()
  MMenu_Add(Menu_MultiSelection , "Anchor Controls","","","iMenu_AnchorControl")
  MMenu_Add(Menu_MultiSelection)
  MultiSelection_CreateMenu(Menu_MultiSelection)

  ;create menus for standard controls
  StandardCtrls := ToolBox_StandardCtrls()
  Loop, Parse, StandardCtrls, `,
  {
    Menu_%A_LoopField% := MMenu_Create()
    If (A_LoopField <> "StatusBar"){
      MMenu_Add(Menu_%A_LoopField% , "Anchor Control","","","iMenu_AnchorControl")
      MMenu_Add(Menu_%A_LoopField%)
    }
  }

  ;Tabpage Submenu
  Menu_TabPages := MMenu_Create()

  ;populate menus for standard controls
  Text_CreateMenu(Menu_Text)
  Edit_CreateMenu(Menu_Edit)
  ComboBox_CreateMenu(Menu_ComboBox)
  Button_CreateMenu(Menu_Button)
  CheckBox_CreateMenu(Menu_CheckBox)
  Radio_CreateMenu(Menu_Radio)
  Picture_CreateMenu(Menu_Picture)
  ListBox_CreateMenu(Menu_ListBox)
  ListView_CreateMenu(Menu_ListView)
  TreeView_CreateMenu(Menu_TreeView)
  Tab_CreateMenu(Menu_Tab, Menu_TabPages)
  HotKey_CreateMenu(Menu_HotKey)
  GroupBox_CreateMenu(Menu_GroupBox)
  DateTime_CreateMenu(Menu_DateTime)
  MonthCal_CreateMenu(Menu_MonthCal)
  Progress_CreateMenu(Menu_Progress)
  UpDown_CreateMenu(Menu_UpDown)
  Slider_CreateMenu(Menu_Slider)
  StatusBar_CreateMenu(Menu_StatusBar)
}

Menu_vCtrlHWND(NewHWND=""){         ;HWND of control for menu
  static HWND
  If NewHWND = No
     HWND =
  Else If NewHWND
     HWND = %NewHWND%
  Else Return %HWND%
}

Menu_vGuiHWND(NewHWND=""){          ;HWND of gui for menu
  static HWND
  If NewHWND = No
     HWND =
  Else If NewHWND
     HWND = %NewHWND%
  Else Return %HWND%
}

Menu_vX(NewX=""){                   ;global X position of menu
  static X
  If NewX = No
     X =
  Else If NewX
     X = %NewX%
  Else Return %X%
}

Menu_vY(NewY=""){                   ;global y position of menu
  static Y
  If NewY = No
     Y =
  Else If NewY
     Y = %NewY%
  Else Return %Y%
}

Menu_AnchorControl:
  Menu_AnchorControl(Menu_vGuiHWND(),Menu_vCtrlHWND())
Return
Menu_AnchorControl(GuiHWND, ListOfCtrlHWND){
  AnchoredCtrls := Gui(GuiHWND, "AnchoredCtrls")
  If InStr(ListOfCtrlHWND,"|"){
    AnchorValue = xy
  }Else {
    AnchorValue := Control(ListOfCtrlHWND,"AnchorValue")
    If !AnchorValue
      AnchorValue = xy
  }

  InputBox, NewAnchorValue, Set Anchor for Controls, Specify an anchor expression.`nNothing will remove any anchor, , , , Menu_vX(), Menu_vY(), , , %AnchorValue%
  If NewAnchorValue {
    Loop, Parse, ListOfCtrlHWND, |
      {
        If ("StatusBar" = Control(A_LoopField,"Type"))
          Continue
        Control(A_LoopField,"AnchorValue", NewAnchorValue)
        If !InStr(AnchoredCtrls,A_LoopField)
            AnchoredCtrls .= "|" A_LoopField
      }
  }Else{
    AnchoredCtrls = |%AnchoredCtrls%|
    Loop, Parse, ListOfCtrlHWND, |
      {
        CtrlHWND = |%A_LoopField%|
        StringReplace, AnchoredCtrls, AnchoredCtrls, %CtrlHWND%, |
      }
  }
  If InStr(AnchoredCtrls,"|") = 1
    StringTrimLeft, AnchoredCtrls, AnchoredCtrls, 1
  If InStr(AnchoredCtrls,"|","",0) = StrLen(AnchoredCtrls)
    StringTrimRight, AnchoredCtrls, AnchoredCtrls, 1
  Gui(GuiHWND, "AnchoredCtrls", AnchoredCtrls)
}

Menu_Anchor(g, c, a = "") {
	static d
  WinGetPos, , , gw, gh, ahk_id %g%
  ControlGetPos, px,py,pw,ph,, ahk_id %c%
	i = x.w.y.h./.7.%gw%.%gh%.`n%g%:%c%=
	StringSplit, i, i, .
	d := a ? d . ((n := !InStr(d, i9)) ? i9 : "")
		: RegExReplace(d, "\n\d+:" . c . "=[\-\.\d\/]+")
	Loop, 4
		x := A_Index, j := i%x%, i6 += x = 3
		, k := !RegExMatch(a, j . "([\d.]+)", v) + (v1 ? v1 : 0)
		, e := p%j% - i%i6% * k, d .= n ? e . i5 : ""
		, RegExMatch(d, "\Q" . i9 . "\E(?:([\d.\-]+)/){" . x . "}", v)
		, l .= p%j% := InStr(a, j) ?  v1 + i%i6% * k : ""
  ControlMove, , px, py, pw, ph, ahk_id %c%
}
