;###############################################################################
/* Project for LilBuilder

*/
;###############################################################################

;check if gui is in the list of project guis
Project_IsUserGUI(HWND){
  Return Instr( "|" Project("ListOfGuiHWND") "|", "|" HWND "|" )
}

;add a gui to the list of project guis
Project_AddUserGUI(HWND){
  ListOfGuiHWND := Project("ListOfGuiHWND") . "|" . HWND
  If InStr(ListOfGuiHWND, "|") = 1                 ;remove first | if any
    StringTrimLeft, ListOfGuiHWND, ListOfGuiHWND, 1
  Project("ListOfGuiHWND", ListOfGuiHWND)
}

;Remove a gui from the list of project guis
Project_RemoveUserGUI(HWND){
  HWND = |%HWND%|
  ListOfGuiHWND := "|" . Project("ListOfGuiHWND") . "|"
  StringReplace, ListOfGuiHWND, ListOfGuiHWND, %HWND%, |
  StringTrimRight, ListOfGuiHWND, ListOfGuiHWND, 1
  StringTrimLeft, ListOfGuiHWND, ListOfGuiHWND, 1
  Project("ListOfGuiHWND", ListOfGuiHWND, ListOfGuiHWND ? "" : "Clear")
}

;dictionary to store all gui relevant properties.
Project(PropertyNameOrAction,Value="",Clear=""){
  Static MasterDic, init = 0

  If !init {  ;set up a master dic once
    init++
    MasterDic := Dic("insensitive")
  }

  If (PropertyNameOrAction = "Remove"){      ;delete dic for project
    Dic("delete",MasterDic)                              ;delete master dic
    init = 0                                             ;reset init state
  }

  Else If (PropertyNameOrAction = "AllPropertyNames"){ ;return all Property Names for project
    Loop, % Dic_Count(MasterDic)
        AllPropertyNames .= "`n" . Dic_NextKey(ForInternalUse, MasterDic)
    StringTrimLeft, AllPropertyNames, AllPropertyNames, 1
    Sort, AllPropertyNames
    Return AllPropertyNames  
  }

  Else If Value is not space  ;assign value
    Dic_Set(MasterDic, PropertyNameOrAction, Value)

  Else If Clear is not space  ;clear value
    Dic_Set(MasterDic, PropertyNameOrAction, "")

  Else ;return value
    Return Dic_Get(MasterDic, PropertyNameOrAction)

  Return 1
}
