;###############################################################################
/* ToolBox for LilBuilder

*/
;###############################################################################

;return toolbox own gui ID
Toolbox_vGuiID(){
  Return 2
}

;return toolbox own gui HWND
Toolbox_vHWND(NewHWND=""){
  static HWND
  If NewHWND
     HWND = %NewHWND%
  Return %HWND%
}

;return list of standard AHK controls 
ToolBox_StandardCtrls(){
  static StandardControls := "Button,CheckBox,ComboBox,DateTime,Edit,GroupBox,HotKey,ListBox,ListView,MonthCal,Picture,Progress,Radio,Slider,StatusBar,Tab,Text,TreeView,UpDown"
  Return StandardControls
}

;create ToolBox gui
Toolbox_Create() {
   local Toolbox_GuiID, Pos, StandardCtrls, CustomCtrls, Option, ShowText              ;global context
   Toolbox_GuiID := Toolbox_vGuiID()
   StandardCtrls := ToolBox_StandardCtrls()
   ShowText := Project("ShowToolBoxIconText")
   CustomCtrls := "HiEdit,HLink,IE,RaGrid"
   
   Gui, %Toolbox_GuiID%:+LastFound +ToolWindow +LabelToolbox_
   Gui, %Toolbox_GuiID%:Margin, 3,4
   
   Gui, %Toolbox_GuiID%:Font, Bold
   Option := ShowText ? "w103" : "w45"
   Gui, %Toolbox_GuiID%:Add, Tab, Left %Option% h390, Standard|Custom
   Gui, %Toolbox_GuiID%:Font, Norm
     Gui, %Toolbox_GuiID%:Tab, Standard
        Option =
        Loop, Parse, StandardCtrls, `,
          {
            If A_Index > 1
              Option = xs
            Gui, %Toolbox_GuiID%:Add, Picture, %Option% Section gToolbox_OnClick vToolBox_Pic%A_LoopField%, res\Standard\%A_LoopField%.png
            If ShowText
              Gui, %Toolbox_GuiID%:Add, Text,x+5 gToolbox_OnClick vToolBox_Txt%A_LoopField%, %A_LoopField%
          }
     Gui, %Toolbox_GuiID%:Tab, Custom
        Option =
        Loop, Parse, CustomCtrls, `,
          {
            If A_Index > 1
              Option = xs
            Gui, %Toolbox_GuiID%:Add, Picture, %Option% Section gToolbox_OnClick vToolBox_Pic%A_LoopField%, res\Custom\%A_LoopField%.png
            If ShowText
              Gui, %Toolbox_GuiID%:Add, Text,x+5 gToolbox_OnClick vToolBox_Txt%A_LoopField%, %A_LoopField%
          }
   Gui, %Toolbox_GuiID%:Tab

   Pos := Project("DockWindows") ? "x-1000" : "x0 y30"
   Gui, %Toolbox_GuiID%:Show, %Pos%, Lil' Builder

   Toolbox_vHWND(WinExist() + 0)
}

;###############################################################################

ToolBox_Close:
 If !Project("DockWindows")
    ExitApp
Return

;react on click on icon in toolbox
Toolbox_OnClick:
   Toolbox_OnClick()
return
Toolbox_OnClick() {
  GuiHWND := Selector_vGuiHWND()
  Toolbox_GuiID := Toolbox_vGuiID()

  ;clear selection
  Selector_Size(False)
  Selector_vCtrlHWND("No")
  Selector_Set2PosSize(-10,-10)
  ToolTip_ShowTips4Pos("Hide")

  ;get type of control
  StringTrimLeft, Type, A_GuiControl, 11
  
  ;re-enable Statusbar when previously deleted but avoid two statusbars
  If (Type = "StatusBar" AND StatusBarHWND := Gui(GuiHWND, "StatusBar")){
    If Gui(GuiHWND, "StatusBarDeleted") {            ;if deleted
      Gui(GuiHWND, "StatusBarDeleted", False)             ;revert deletion state
      GuiID := Gui(GuiHWND, "GuiID")
      CtrlID := Control(StatusBarHWND,"VarName")
      GuiControl, %GuiID%:Show, %CtrlID%                  ;show statusbar
      Gui_AddControl(GuiHWND,StatusBarHWND)               ;add statusbar to list of controls on gui
    }
    Else                                             ;don't try to add a second
      ToolTip("Gui has already a Statusbar",2000,"Continue")
    Return
  }

  ;create the control
  CtrlHWND := Control_CreateNew(Type, GuiHWND)

  ;return for statusbar
  If (Type = "StatusBar")
  
  ;set control as selected
  Selector_vCtrlHWND(CtrlHWND)
  
  ;move mouse to center of control
  If Gui(GuiHWND,"Toolwindow"){
    ;window frame height/width of a toolwindow gui
    SysGet, XFrame,  7   ;SM_CXFIXEDFRAME =  7   ;width of frame
    SysGet, YFrame,  8   ;SM_CYFIXEDFRAME =  8   ;height of frame
    SysGet, HCaption, 51 ;SM_CYSMCAPTION  = 51   ;height of caption, the whole title height is: SM_CYSMCAPTION + SM_CYFIXEDFRAME
  }Else{
    ;window frame height/width of a regular gui
    SysGet, XFrame, 32   ;SM_CXSIZEFRAME = 32    ;width of frame
    SysGet, YFrame, 33   ;SM_CYSIZEFRAME = 33    ;height of frame
    SysGet, HCaption, 4  ;SM_CYCAPTION   =  4    ;height of caption, the whole title height is: SM_CYCAPTION + SM_CYSIZEFRAME
  }
  WinGetPos, ux, uy,,, ahk_id %GuiHWND%
  ControlGetPos, ,,cw,ch,, ahk_id %CtrlHWND%
  KeyWait, LButton     ;wait for release of LButton
  MouseMove, ux + cw // 2, uy + YFrame + HCaption + ch // 2

  Selector_Set2Ctrl()  ;set selector to control 

  Sleep, 20
  Selector_Size(True)
  Send {LButton down}  ;prepare movement
}

;###############################################################################

